unit hiTabControlEx; {   ver 3.30}

interface

{$I share.inc}

uses Windows,Kol,Share,Win;

type
 ThiTabControlEx = class(THIWin)
   private
     Arr:Array Of AnsiString;
     Ars:array of string;
     IList:PImageList;
     FGradient: boolean;
     FDepthGradient:integer;
     FBumpText: boolean;
     FInversColor: boolean;
     FColorGradient: TColor;
     FButtons: boolean;
     FBottom: boolean;
     FHorizontal: boolean;
     FInversGrad: boolean;     
     FImgSize: byte;
     procedure _OnChange(Obj:PObj);
     function  _OnDrawItem( Sender: PObj; DC: HDC; const Rect: TRect; ItemIdx: Integer;
                            DrawAction: TDrawAction; ItemState: TDrawState ): Boolean;
     procedure SetBitmaps(const value:PStrListEx);
   public
     _prop_Extended:boolean;
          
     _prop_Tabs:string;

     _prop_HotTrack:boolean;
     _prop_FocusTabs:boolean;
     _prop_Vertical:boolean;
     _prop_Border:boolean;

     _data_NewPageText:THI_Event;
     _data_Index:THI_Event;
     _event_onChange:THI_Event;

    property _prop_Icons:PStrListEx      write SetBitmaps;
    property _prop_ImgSize:byte          write FImgSize;
    property _prop_Gradient:boolean      write FGradient;
    property _prop_DepthGradient:integer write FDepthGradient;
    property _prop_BumpText:boolean      write FBumpText;
    property _prop_InversColor:boolean   write FInversColor;
    property _prop_ColorGradient:TColor  write FColorGradient;
    property _prop_Buttons:boolean       write FButtons;
    property _prop_Bottom:boolean        write FBottom;    
    property _prop_Horizontal:boolean    write FHorizontal;
    property _prop_InversGrad:boolean    write FInversGrad;

    procedure Init; override;
    procedure _work_PageInsert(var _Data:TData;Index:word);
    procedure _work_PageTab(var _Data:TData;Index:word);
    procedure _var_CurTabIndx(var _Data:TData; Index:word);
    procedure _var_CurTabCaption(var _Data:TData; Index:word);
    procedure _work_PageDelete(var _Data:TData; Index:word);
    procedure _var_TabCount(var _Data:TData; Index:word);

    procedure _work_doGradient(var _Data:TData; Index:word);
    procedure _work_doDepthGradient(var _Data:TData; Index:word);
    procedure _work_doColorGradient(var _Data:TData; Index:word);
    procedure _work_doBumpText(var _Data:TData; Index:word);
    procedure _work_doInversColor(var _Data:TData; Index:word);
    procedure _work_doHorizontal(var _Data:TData; Index:word);
    procedure _work_doInversGrad(var _Data:TData; Index:word);
end;

function MakeArrayIcon(Names:PChar; Values:array of integer):PStrListEx;

implementation

function MakeArrayIcon;begin Result:= MakeArrayInteger(Names,Values);end;

//-----------------------       ----------------------

type
  TRGB = packed record
    R, G, B, X: Byte;
  end;

  AGRBQuad = array [0..0] of RGBQuad;
  PAGRBQuad = ^AGRBQuad;

function GetRGB(const Color: TColor): TRGB;
var
  iColor: TColor;
begin
  iColor := Color2RGB(Color);
  Result.R := GetRValue(iColor);
  Result.G := GetGValue(iColor);
  Result.B := GetBValue(iColor);
end;

function GetLightColor(Color: TColor; Light: Byte) : TColor;
var
  fFrom: TRGB;
begin
  FFrom := GetRGB(Color);
  Result := RGB(
    Round(FFrom.R + (255 - FFrom.R) * (Light / 100)),
    Round(FFrom.G + (255 - FFrom.G) * (Light / 100)),
    Round(FFrom.B + (255 - FFrom.B) * (Light / 100))
  );
end;

function  GetShadeColor(Color: TColor; Shade: Byte) : TColor;
var
  fFrom: TRGB;
begin
  FFrom := GetRGB(Color);
  Result := RGB(
    Max(0, FFrom.R - Shade),
    Max(0, FFrom.G - Shade),
    Max(0, FFrom.B - Shade)
  );
end;

//******************************  **************************************
  
type
  COLOR16 = $0000..$FF00;
  TTriVertex = packed record
    x, y: DWORD;
    Red, Green, Blue, Alpha: COLOR16;
  end;
function GradientFill(DC: HDC; Vertex: Pointer; NumVertex: Cardinal;
                      Mesh: Pointer; NumMesh, Mode: DWORD): BOOL; stdcall;
                      external 'msimg32.dll' name 'GradientFill';

procedure _Gradient(Sender:PControl; DC:HDC; cbRect:TRect; Gradient:boolean; StartColor,EndColor:TColor; Horizontal,InversGrad:boolean);
var   hdcMem:HDC;
      hdcBmp:HBITMAP;
      hWidth,hHeight:integer;
      vert: array[0..1] of TTriVertex;
      gRect: TGradientRect;
begin
      hWidth:= cbRect.Right - cbRect.Left;
      hHeight:= cbRect.Bottom - cbRect.Top;

      hdcMem:= CreateCompatibleDC(DC);
      hdcBmp:= CreateCompatibleBitmap(DC,hWidth,hHeight);
      SelectObject(hdcMem, hdcBmp);

      StartColor := Color2RGB(StartColor);
      EndColor := Color2RGB(EndColor); 

      if not Gradient then EndColor := StartColor; 
       
      vert[0].x      := 0;
      vert[0].y      := 0;
      vert[1].x      := hWidth;
      vert[1].y      := hHeight;
      vert[0].Alpha  := $0000; // ???
      vert[1].Alpha  := vert[0].Alpha;  

      if not InversGrad then begin
         vert[0].Red    := GetRValue(StartColor) shl 8;
         vert[0].Green  := GetGValue(StartColor) shl 8;
         vert[0].Blue   := GetBValue(StartColor) shl 8;
         vert[1].Red    := GetRValue(EndColor) shl 8;
         vert[1].Green  := GetGValue(EndColor) shl 8;
         vert[1].Blue   := GetBValue(EndColor) shl 8;
      end else begin
         vert[1].Red    := GetRValue(StartColor) shl 8;
         vert[1].Green  := GetGValue(StartColor) shl 8;
         vert[1].Blue   := GetBValue(StartColor) shl 8;
         vert[0].Red    := GetRValue(EndColor) shl 8;
         vert[0].Green  := GetGValue(EndColor) shl 8;
         vert[0].Blue   := GetBValue(EndColor) shl 8;
      end;


      gRect.UpperLeft  := 0;
      gRect.LowerRight := 1;

      if Horizontal then
         GradientFill(hdcMem, @vert, 2, @gRect, 1, GRADIENT_FILL_RECT_H)
      else
         GradientFill(hdcMem, @vert, 2, @gRect, 1, GRADIENT_FILL_RECT_V);

      BitBlt(DC, cbRect.Left, cbRect.Top, hWidth, hHeight, hdcMem, 0, 0, SRCCOPY);
      DeleteDC(hdcMem);
      DeleteObject(hdcBmp);
end;

//******************************************************************************
procedure ThiTabControlEx._work_doGradient;begin FGradient:= ReadBool(_Data);Control.Invalidate;end;
procedure ThiTabControlEx._work_doInversColor;begin FInversColor:= ReadBool(_Data);Control.Invalidate;end;
procedure ThiTabControlEx._work_doDepthGradient;begin FDepthGradient:= ToIntIndex(_Data);Control.Invalidate;end;
procedure ThiTabControlEx._work_doColorGradient;begin FColorGradient:= ToInteger(_Data);Control.Invalidate;end;
procedure ThiTabControlEx._work_doBumpText;begin FBumpText:= ReadBool(_Data);Control.Invalidate;end;
procedure ThiTabControlEx._work_doHorizontal;begin FHorizontal:= ReadBool(_Data);Control.Invalidate;end;
procedure ThiTabControlEx._work_doInversGrad;begin FInversGrad:= ReadBool(_Data);Control.Invalidate;end;

//------------------------       ----------------------

procedure ThiTabControlEx.Init;
var i:integer;
    Lst:PStrList;
    tco:TTabControlOptions;
begin
   tco:=[];
   if FButtons        then include(tco,tcoButtons);
   if FBottom         then include(tco,tcoBottom);
   if _prop_Vertical and (not _prop_Extended) then include(tco,tcoVertical);
   if _prop_HotTrack and (not _prop_Extended) then include(tco,tcoHotTrack);
   if _prop_FocusTabs then include(tco,tcoFocusTabs);
   if _prop_Border    then include(tco,tcoBorder);

// array Of AnsiString;
   Lst := NewStrList;
   Lst.text := _prop_Tabs;
   if Lst.Count > 0 then begin
      SetLength(Arr,Lst.Count);
      SetLength(Ars,Lst.Count);
      for i := 0 to Lst.Count-1 do begin
         Ars[i] := Lst.Items[i];
         Arr[i] := PChar(Ars[i]);
      end;
   end;
// 
   if _prop_Extended then include(tco,tcoOwnerDrawFixed);
   Control:= NewTabControl(FParent,Arr,tco,IList,0);   
   Control.OnDrawItem:= _OnDrawItem;
inherited;
   Control.OnSelChange:= _OnChange;
end;

//---------------------       -----------------------

function ThiTabControlEx._OnDrawItem;
var   ARect,BRect,cbRect: TRect;
      fControl: PControl;
      _Flags: dword;
      aWidth, TextExtCy:integer;
      OffsetTH, OffsetPH:integer;
      aText:string;
begin
   fControl:= PControl(Sender);

   with fControl{$ifndef F_P}^{$endif} do begin
      aText:= TC_Items[ItemIdx];
      _Flags:=  DT_SINGLELINE or DT_VCENTER or DT_NOPREFIX;    

      cbRect:= Rect;
      SetBkMode(DC, Font.Color);

      if (odsSelected in ItemState) then begin
         _Gradient(fControl,DC,cbRect,FGradient,FColorGradient,
                   GetLightColor(FColorGradient, FDepthGradient),FHorizontal,not FInversGrad);
      end else begin
         Canvas.Brush.Color:= Color;
         SetTextColor(DC,Color2RGB(Font.Color));
         FillRect(DC,cbRect,Canvas.Brush.Handle)
      end;

      aWidth:= Canvas.TextWidth(aText);
      TextExtCy:= Canvas.TextExtent('W').cy;

      ARect:= Rect;

      with ARect do begin
         OffsetTH:= Bottom - Top - Canvas.TextExtent('W').cy;
         if not (odsSelected in ItemState) then begin
            Right:= Right - 6;
            Left:= Right - aWidth;
            if not FBottom then begin
               if not FButtons then
                  Top:= Top + (OffsetTH + 4) div 2
               else
                  Top:= Top + (OffsetTH - 2) div 2;            
               Bottom:= Top + TextExtCy;
            end
            else begin
               if not FButtons then
                  Bottom:= Bottom - (OffsetTH + 4) div 2
               else
                  Bottom:= Bottom - (OffsetTH - 2) div 2;
               Top:= Bottom - TextExtCy;
            end;
         end
         else if (odsSelected in ItemState) then begin 
            if not FButtons then
               Right:= Right - 10
            else
               Right:= Right - 5;
            Left:= Right - aWidth;
            if not FBottom then begin
               if not FButtons then
                  Top:=  Top + (OffsetTH - 2) div 2
               else         
                  Top:=  Top + OffsetTH div 2; 
               Bottom:= Top + TextExtCy;
            end 
            else
               if not FButtons then
                  Bottom:= Bottom - (OffsetTH - 2) div 2
               else
                  Bottom:= Bottom - OffsetTH div 2;            
               Top:= Bottom - TextExtCy;            
         end;
      end; 

      BRect:= ARect; 
      inc(BRect.Right);
      inc(BRect.Left);
      inc(BRect.Top);
      inc(BRect.Bottom);
         
      if FBumpText and FGradient then begin
         if (odsSelected in ItemState) then begin 
            if FInversColor then 
               SetTextColor(DC,GetShadeColor(Font.Color, 100))
            else
               SetTextColor(DC,Color2RGB(clHighlightText));
            DrawText(DC, PChar(aText), -1, BRect, _Flags);
            if FInversColor then
               SetTextColor(DC,Color2RGB(clHighlightText))
            else
               SetTextColor(DC,Color2RGB(Font.Color));
         end else
            SetTextColor(DC,Color2RGB(Font.Color));
      end
      else
         if (odsSelected in ItemState) then begin 
            if FInversColor then
               SetTextColor(DC,Color2RGB(clHighlightText))
            else
               SetTextColor(DC,Color2RGB(Font.Color));
         end else
            SetTextColor(DC,Color2RGB(Font.Color));
         DrawText(DC, PChar(aText), -1, ARect, _Flags);

      cbRect:= Rect;
      
      with cbRect do begin
         OffsetPH:= Bottom - Top - FImgSize;
         if not (odsSelected in ItemState) then begin
            Left:= left + 4;
            Right:= Left + FImgSize;
            if not FBottom then begin
               if not FButtons then
                  Top:= Top + (OffsetPH + 4) div 2
               else
                  Top:= Top + (OffsetPH - 2) div 2;            
               Bottom:= Top + FImgSize;
            end
            else begin
               if not FButtons then
                  Bottom:= Bottom - (OffsetPH + 4) div 2
               else
                  Bottom:= Bottom - (OffsetPH - 2) div 2;
               Top:= Bottom - FImgSize;
            end;
         end
         else if (odsSelected in ItemState) then begin 
            if not FButtons then
               Left:= left + 8
            else
               Left:= left + 5; 
            Right:= Left + FImgSize;
            if not FBottom then begin
               if not FButtons then
                  Top:=  Top + (OffsetPH - 2) div 2
               else
                  Top:=  Top + OffsetPH div 2;
               Bottom:= Top + FImgSize;
            end 
            else
               if not FButtons then
                  Bottom:= Bottom - (OffsetPH - 2) div 2
               else
                  Bottom:= Bottom - OffsetPH div 2;
               Top:= Bottom - FImgSize;            
         end;
      end; 
      Result:= True; 
   
      if not Assigned(IList) then exit;

      IList.DrawingStyle:= [dsTransparent];      
      IList.StretchDraw(ItemIdx,DC,cbRect);
   end;
end;

procedure ThiTabControlEx._OnChange;
begin
   _hi_OnEvent(_event_onChange,Control.CurIndex);
end;

procedure ThiTabControlEx._work_PageInsert;
var s:string;
    ind:integer;
begin
  s:= ReadString(_Data,_data_NewPageText,'');
  ind:= ReadInteger(_Data,_data_Index,0);
  Control.TC_Insert(ind,s,ind);
end;

procedure ThiTabControlEx._work_PageDelete;
var   ind:integer;
begin
   ind:= ReadInteger(_Data,_data_Index,0);
   Control.TC_Delete(ind);
end;

procedure THITabControlEx._work_PageTab;
begin
  Control.CurIndex := ToInteger(_Data);
end;

procedure ThiTabControlEx._var_CurTabIndx;
begin
   dtInteger(_Data, Control.CurIndex);
end;

procedure ThiTabControlEx._var_CurTabCaption;
begin
   dtString(_Data, Control.TC_Items[Control.CurIndex]); 
end;

procedure ThiTabControlEx._var_TabCount;
begin
   dtInteger(_Data, Control.Count);
end;

procedure ThiTabControlEx.SetBitmaps;
var   i:integer;
begin
   if _prop_Extended then 
      IList := NewImageList(nil)
   else
      IList := NewImageList(Applet);
   for i:= 0 to Value.Count - 1 do begin
      IList.ImgWidth := FImgSize;
      IList.ImgHeight := FImgSize;
      IList.DrawingStyle:= [dsTransparent];
      IList.AddIcon(value.Objects[i]);
   end;
end;

end.